%{
#line 42 "./mixal.yw"
#ifdef HAVE_CONFIG_H
#include <config.h> 
#endif
#include <stdlib.h> 
#include <stdio.h> 
#include <string.h> 
#include <stdarg.h> 
#include <errno.h> 
#include <unistd.h> 
#include <fcntl.h> 
#include <ctype.h> 
#include <mix.h> 
#include <mixasm.h> 

/*:2*//*4:*/
#line 60 "./mixal.yw"


#define update_memory(A) memory[location_counter]= (A) ;lines[lineno]= location_counter++;
#define LIST_SUFFIX ".lst" \


#line 61 "./mixal.yw"


char*progname;
char*source_file= NULL;

char*listfile= "mixal.lst";
FILE*lst;

int lineno= 1;
int location_counter= 0;
int start_location= MEMSIZE;
unsigned memory[MEMSIZE];
int lines[MEMSIZE];
int opfield;
int error_count;

/*:4*//*5:*/
#line 77 "./mixal.yw"


int list= 0;
int xref= 0;
int writeraw= 0;

/*:5*//*6:*/
#line 83 "./mixal.yw"


FILE*create_temp(char*tmpl);
int word_s(unsigned w);
void symbols(void);
void end_routine(int start);
int num(char*text);
void warning(char*s,char*t);
void listing();
void dumpsymtab(FILE*fp);
void resolve_forward(Symbol*f);

unsigned add_mix(unsigned a,unsigned b);
unsigned sub_mix(unsigned a,unsigned b);
unsigned div_mix(unsigned a,unsigned b);
unsigned mul_mix(unsigned a,unsigned b);
unsigned w_eval(unsigned a,unsigned b,int f);

/*:6*//*7:*/
#line 101 "./mixal.yw"


%}

	/*:7*//*9:*/

%union{
unsigned val;
Symbol*symp;
char*txt;
char literal[6];
struct mix_op*opcode;
}

	/*:9*//*10:*/

%token<symp> DEFINED_SYMBOL
%token<symp> LOCAL_SYMBOL
%token<symp> FUTURE_REFERENCE
%token<symp> LOC
%token<symp> END
%token<val> UNDEF
%token<val> DEF
%token<val> NUMBER
%token<val> ASTERISK
%token<txt> TEXT
%token<literal> ALF PSEUDO
%token<opcode> OPCODE
%token BOGUS
%left'-''+'
%left'*''/'
%left':'SLASHES
%nonassoc UMINUS

	/*:10*//*11:*/

%type<val> expression
%type<val> atomic_expression
%type<val> a_part i_part f_part w_value
%type<symp> literal_constant
%type<symp> label
%type<opcode> op
%type<literal> pseudo

%%
	/*:11*//*13:*/
statement_list:statement comment eol
|statement_list statement comment eol
;
	/*:13*//*14:*/
statement_list:statement_list error eol
	{
#line 165 "./mixal.yw"
	yyerrok;
	yyclearin;
	reset_lex();
	}
	/*:14*//*15:*/
eol:'\n'
	{
#line 173 "./mixal.yw"
	lineno++;}
|eol'\n'
	{
#line 175 "./mixal.yw"
	lineno++;}
;
	/*:15*//*16:*/
statement:label op a_part i_part f_part
	{
#line 182 "./mixal.yw"
	unsigned word;
	word= $2->c|SIGN($3)|MAG($3)*B3|$4*B2|$5*B1;
	update_memory(word);
	}
;
	/*:16*//*17:*/
statement:label pseudo w_value
	{
#line 193 "./mixal.yw"
	if(!strcmp($2,"EQU")){
	if($1==NULL)
	dumpsymtab(stderr);
	else
	$1->value= $3;
	}else if(!strcmp($2,"ORIG")){
	location_counter= word_s($3);
	}else if(!strcmp($2,"CON")){
	update_memory($3);
	}else if(!strcmp($2,"END")){
	if($1!=NULL)
	$1->type= END;
	start_location= $3;
	YYACCEPT;
	}
	}
|label ALF
	{
#line 212 "./mixal.yw"
	update_memory(num($2));
	}
|ASTERISK{;}
;
	/*:17*//*18:*/
label:
	{
#line 221 "./mixal.yw"
	$$= NULL;
	}
|LOC
	{
#line 225 "./mixal.yw"
	if(localref($1->name,"FB")){
	yyerror("invalid label");
	YYERROR;
	}
	$1->type= DEF;
	$1->line= lineno;
	$1->value= location_counter;
	$$= $1;
	}
;
	/*:18*//*19:*/
comment:
|TEXT	{
#line 239 "./mixal.yw"
	;}
;
	/*:19*//*20:*/
op:OPCODE
	{
#line 246 "./mixal.yw"
	opfield= $1->f;
	}
;
	/*:20*//*21:*/
pseudo:PSEUDO
	{
#line 255 "./mixal.yw"
	opfield= 5;
	}
;
	/*:21*//*22:*/
expression:atomic_expression
|'+'atomic_expression%prec UMINUS
	{
#line 264 "./mixal.yw"
	$$= $2;
	}
|'-'atomic_expression%prec UMINUS
	{
#line 268 "./mixal.yw"
	$$= $2^MINUS;
	}
|expression'+'atomic_expression
	{
#line 272 "./mixal.yw"
	$$= add_mix($1,$3);
	}
|expression'-'atomic_expression
	{
#line 276 "./mixal.yw"
	$$= sub_mix($1,$3);
	}
|expression ASTERISK atomic_expression%prec'*'
	{
#line 280 "./mixal.yw"
	$$= mul_mix($1,$3);
	}
|expression'/'atomic_expression
	{
#line 284 "./mixal.yw"
	$$= div_mix($1,$3);
	}
|expression SLASHES atomic_expression
	{
#line 288 "./mixal.yw"
	$$= mul_mix($1,B5/MAG($3));
	}
|expression':'atomic_expression
	{
#line 292 "./mixal.yw"
	$$= add_mix(mul_mix($1,8),$3);
	}
;
	/*:22*//*23:*/
atomic_expression:NUMBER
|ASTERISK
	{
#line 301 "./mixal.yw"
	$$= location_counter;
	}
|DEFINED_SYMBOL
	{
#line 305 "./mixal.yw"
	$$= $1->value;
	if(xref)
	$1->xref= addref($1->xref,location_counter,
	lineno);
	}
|LOCAL_SYMBOL
	{
#line 312 "./mixal.yw"
	$$= $1->value;
	}
;
	/*:23*//*24:*/
a_part:
	{
#line 320 "./mixal.yw"
	$$= 0;
	}
|expression
|FUTURE_REFERENCE
	{
#line 325 "./mixal.yw"
	$1->reflist= addref($1->reflist,location_counter,lineno);
	if(xref)
	$1->xref= addref($1->xref,location_counter,
	lineno);
	$$= 0;
	}
|literal_constant
	{
#line 333 "./mixal.yw"
	$$= 0;
	}
;
	/*:24*//*25:*/
i_part:
	{
#line 341 "./mixal.yw"
	$$= 0;
	}
|','expression
	{
#line 345 "./mixal.yw"
	$$= $2;
	}
;
	/*:25*//*26:*/
f_part:
	{
#line 353 "./mixal.yw"
	$$= opfield;
	}
|'('expression')'
	{
#line 357 "./mixal.yw"
	$$= $2;
	}
;
	/*:26*//*27:*/
w_value:expression f_part
	{
#line 365 "./mixal.yw"
	$$= w_eval(0,$1,$2);
	}
|w_value','expression f_part
	{
#line 369 "./mixal.yw"
	$$= w_eval($1,$3,$4);
	}
;
	/*:27*//*28:*/
literal_constant:'='w_value'='
	{
#line 377 "./mixal.yw"
	char literal[13];
	Symbol*s;
	sprintf(literal,"=%d=",word_s($2));
	if(!(s= lookup(literal)))
	s= install(literal,$2,lineno);
	s->reflist= addref(s->reflist,location_counter,lineno);
	if(xref)
	s->xref= addref(s->xref,location_counter,lineno);
	}
;
%%
#line 391 "./mixal.yw"

/*:28*//*30:*/
#line 393 "./mixal.yw"


unsigned
add_mix(unsigned a,unsigned b)
{
unsigned s,t;

s= SIGN(a);
t= SIGN(b);
if(s!=t){
if(MAG(a)> MAG(b)){
a= MAG(a)-MAG(b);
t= s;
}else
a= MAG(b)-MAG(a);
}else
a= MAG(a)+MAG(b);
if(a> B5-1)
yyerror("Arithmetic result greater than 1073741823");
return a|t;
}

/*:30*//*31:*/
#line 415 "./mixal.yw"


unsigned
sub_mix(unsigned a,unsigned b)
{
b^= MINUS;
return add_mix(a,b);
}


/*:31*//*32:*/
#line 425 "./mixal.yw"


unsigned
mul_mix(unsigned a,unsigned b)
{
unsigned s;
long long w;
s= SIGN(a)==SIGN(b)?PLUS:MINUS;
if((w= MAG(a)*MAG(b))> B5-1)
yyerror("Arithmetic result greater than 1073741823");
return s|MAG(w);
}

/*:32*//*33:*/
#line 438 "./mixal.yw"


unsigned
div_mix(unsigned a,unsigned b)
{
return SIGN(a)|MAG(MAG(a)/MAG(b));
}

/*:33*//*34:*/
#line 446 "./mixal.yw"


unsigned
w_eval(unsigned x,unsigned y,int f)
{
int l,r;
unsigned sign,mask;

l= f/8;
r= f%8;
mask= B5-1;
if(l<0||l> r||r> 5)
yyerror("Invalid F-part");
if(l==0){
sign= MINUS&y;
l= 1;
}else sign= MINUS&x;
y<<= (4-r+l)*BYTESIZE;

y= MAG(y);
y>>= (l-1)*BYTESIZE;
mask<<= (4-r+l)*BYTESIZE;
mask= MAG(mask);
mask>>= (l-1)*BYTESIZE;
x&= ~mask;
x= MAG(x);
x|= y;
x|= sign;
return x;
}

/*:34*//*35:*/
#line 477 "./mixal.yw"


int
word_s(unsigned w)
{
if(w&MINUS)w= -MAG(w);
return w;
}

/*:35*//*36:*/
#line 486 "./mixal.yw"


int
yyerror(char*s)
{
warning(s,(char*)0);
}

/*:36*//*37:*/
#line 494 "./mixal.yw"


void
warning_l(int line,char*s,char*t)
{
fprintf(stderr,"%s: %s",progname,s);
if(t)
fprintf(stderr," %s",t);
fprintf(stderr," near line %d\n",line);
error_count++;
}

/*:37*//*38:*/
#line 506 "./mixal.yw"


void
warning(char*s,char*t)
{
warning_l(lineno,s,t);
}

/*:38*//*39:*/
#line 514 "./mixal.yw"


void
print_version()
{
printf("%s (%s)\n",progname,PACKAGE_STRING);
}

/*:39*//*40:*/
#line 522 "./mixal.yw"


void
usage()
{
printf("usage: %s [-d L][-fhlrxV] [filename]\n",progname);
}

/*:40*//*41:*/
#line 530 "./mixal.yw"


void
init_keywords()
{
int i;
for(i= 0;i<op_count;i++)
install_op(&mix_optab[i]);
}

/*:41*//*42:*/
#line 540 "./mixal.yw"


int
main(int argc,char*argv[])
{
int lexdebug= 0;
int i;
char*p;
int force= 0;

progname= strrchr(argv[0],'/');
if(progname)
progname++;
else
progname= argv[0];

if(argc> 1&&memcmp(argv[1],"--",2)==0){

if(strcmp(argv[1],"--help")==0)
usage();
else if(strcmp(argv[1],"--version")==0)
print_version();
else
fprintf(stderr,"Unknown option: %s\n",argv[1]);
exit(0);
}
while((i= getopt(argc,argv,"d:hlrVx"))!=EOF){
switch(i){
case'd':
for(p= optarg;*p;p++){
switch(*p){
case'y':
yydebug= 1;
break;

case'l':
lexdebug= 1;
break;

default:
fprintf(stderr,"invalid debugging level: %c\n",*p);
break;
}
}
break;
case'f':
force= 1;
break;
case'l':
list= 1;
break;
case'r':
writeraw= 1;
break;
case'V':
print_version();
exit(0);
case'x':
xref= 1;
break;
case'h':
usage();
exit(0);
default:
exit(1);
}
}
if(argc> optind){
FILE*fp;
source_file= argv[optind];
if((fp= fopen(source_file,"r"))==NULL){
fprintf(stderr,"can't open %s: %s\n",source_file,
strerror(errno));
exit(1);
}
init_lex(fp,lexdebug);
if(list){
unsigned len;
char*p= strrchr(source_file,'.');
if(p)
len= p-source_file;
else
len= strlen(source_file);
listfile= malloc(len+sizeof(LIST_SUFFIX));
if(!listfile)
abort();
memcpy(listfile,source_file,len);
strcat(listfile,LIST_SUFFIX);
}
}else
init_lex(stdin,lexdebug);
if(list)
lst= create_temp("lstXXXXXX");

for(i= 0;i<MEMSIZE;i++)
lines[i]= -1;
init_keywords();
error_count+= yyparse();

if(start_location==MEMSIZE)
warning("No END statement in program",NULL);
else{
symbols();
end_routine(word_s(start_location));
}

if(error_count&&!force)
exit(1);

if(list)
listing();
else if(xref)
dumpsymtab(stderr);

exit(error_count> 0);
}

/*:42*//*43:*/
#line 657 "./mixal.yw"


FILE*
create_temp(char*tmpl)
{
char*buf;
char*tmp;
int fd;
FILE*fp;

if((tmp= getenv("TMP"))==NULL&&(tmp= getenv("TEMP"))==NULL)
tmp= "/tmp";
buf= malloc(strlen(tmp)+1+strlen(tmpl)+1);
if(!buf)
abort();
sprintf(buf,"%s/%s",tmp,tmpl);

#ifdef HAVE_MKSTEMP
{
int save_mask= umask(077);
fd= mkstemp(buf);
umask(save_mask);
}
#else
if(mktemp(buf))
fd= open(filename,O_CREAT|O_EXCL|O_RDWR,0600);
else
fd= -1;
#endif

if(fd==-1){
fprintf(stderr,"can't create temporary file %s: %s\n",
tmp,strerror(errno));
exit(1);
}

unlink(buf);
free(buf);
return fdopen(fd,"w+");
}

/*:43*//*44:*/
#line 698 "./mixal.yw"


void
listing()
{
FILE*fp;
char buf[512];
int i,l;

rewind(lst);

fp= fopen(listfile,"w");
if(fp==NULL){
fprintf(stderr,"can't open %s: %s\n",listfile,strerror(errno));
exit(1);
}

for(l= 1;l<=lineno;l++){
if((i= lines[l])!=-1){
int Av,Iv,Fv,Cv,Sv;
Sv= (memory[i]&MINUS)?'-':'+';
Av= (memory[i]&(B5-1))>>3*BYTESIZE;
Iv= (memory[i]&(B3-1))>>2*BYTESIZE;
Fv= (memory[i]&(B2-1))>>BYTESIZE;
Cv= (memory[i]&(B1-1));
fprintf(fp,"%4d: %c %4d %2d %2d %2d   %3d ",
i,Sv,Av,Iv,Fv,Cv,l);
}else
fprintf(fp,"%23s %3d "," ",l);

if(fgets(buf,sizeof(buf),lst))
fputs(buf,fp);
else
fputs("\n",fp);
}
fputs("\n",fp);
dumpsymtab(fp);
fclose(fp);
}


/*:44*//*45:*/
#line 739 "./mixal.yw"


void
dumpsymtab(FILE*fp)
{
Symbol**symbols= sort_symbols();
int i;
ref*refp;

fprintf(fp,"\nSymbol     Value  Line");
if(xref){
fprintf(fp,"  Referenced on line");
}
fprintf(fp,"\n");
for(i= 0;symbols[i];i++){
Symbol*s= symbols[i];
fprintf(fp,"%-10s  %4d %4d",
s->name,word_s(s->value),s->line);
if(xref){
sort_refs(s);
for(refp= s->xref;refp;refp= refp->next){
if(refp->line!=s->line)
fprintf(fp," %4d",refp->line);
}
}
fprintf(fp,"\n");
}
free(symbols);
}

/*:45*//*46:*/
#line 769 "./mixal.yw"


void
tlist(char*fmt,...)
{
va_list ap;

if(!lst)
return;
va_start(ap,fmt);
vfprintf(lst,fmt,ap);
va_end(ap);
}

/*:46*//*47:*/
#line 783 "./mixal.yw"


int
sym_eval_wexpr(Symbol*s)
{
if(s->name[0]=='='){
memory[location_counter]= w_eval(0,s->value,5);
s->value= location_counter++;
}
if(s->type==UNDEF){
if(s->name[0]=='|'){
warning_l(s->line,"missing 'forward here'",NULL);
}else{
fprintf(stderr,"Warning: '%-10s CON  0' inserted at %d:\n",
s->name,location_counter);
memory[location_counter]= 0;
s->value= location_counter++;
s->type= DEF;
}
}
return 0;
}

/*:47*//*48:*/
#line 806 "./mixal.yw"


static int
sym_resolve(Symbol*s)
{


if(s->type==END)
s->value= location_counter;


resolve_forward(s);
return 0;
}

/*:48*//*49:*/
#line 821 "./mixal.yw"


void
symbols()
{
iterate(sym_eval_wexpr);
iterate(sym_resolve);
}

/*:49*//*50:*/
#line 830 "./mixal.yw"


char loader[]= 
" O O6 Z O6    I C O4 0 EH A  F F CF 0  E   EU 0 IH G BB   EJ  CA. Z EU   EH E BA\n"
"   EU 2A-H S BB  C U 1AEH 2AEN V  E  CLU  ABG Z EH E BB J B. A  9               \n";

/*:50*//*51:*/
#line 836 "./mixal.yw"


void
end_routine(int start)
{
long address,loc,sign,value;
int i,j,flag;
char field[7][11];
char title[6];

if(source_file){
char*p;
if(p= strrchr(source_file,'/'))
p++;
else
p= source_file;
for(i= 0;i<5&&p[i];i++)
title[i]= toupper(p[i]);
title[i]= '\0';
}else
strcpy(title,"MIXAL");

if(writeraw){
int count= 0;
for(i= 0;i<=32;i++){
printf("%c%c%c%c%c",
mixalf[((memory[i]&(B5-1))>>4*BYTESIZE)&(B1-1)],
mixalf[((memory[i]&(B5-1))>>3*BYTESIZE)&(B1-1)],
mixalf[((memory[i]&(B3-1))>>2*BYTESIZE)&(B1-1)],
mixalf[((memory[i]&(B2-1))>>BYTESIZE)&(B1-1)],
mixalf[(memory[i]&(B1-1))]);
count++;
if(count%16==0)
printf("\n");
}
return;
}


printf("%s",loader);

flag= i= 0;
for(address= 0;address<MEMSIZE;address++)
if(memory[address]){
sign= memory[address]&MINUS?-1:1;
value= MAG(memory[address]);
if(!flag)
flag= 1,loc= address;
if(address!=loc+i||i>=7){
printf("%-5s%1d%04ld",title,i,loc);
for(j= 0;j<i;j++)
printf("%10s",field[j]);
printf("\n");
loc= address;
i= 0;
}
sprintf(field[i],"%010ld",value);
if(sign<0)
field[i][9]= "~JKLMNOPQR"[field[i][9]-'0'];
i++;
}
printf("%-5s%1d%04ld",title,i,loc);
for(j= 0;j<i;j++)
printf("%10s",field[j]);
printf("\n");
printf("TRANS0%04d\n",start);
}

/*:51*//*52:*/
#line 904 "./mixal.yw"


int
num(char*text)
{
int i,n;
char*p;

n= 0;
for(i= 0;i<5;i++)
if(!text[i])
n= n*B1;
else if(p= strchr(mixalf,text[i]))
n= n*B1+(p-mixalf);
else
yyerror("bad character in ALF constant");
return n;
}

/*:52*//*53:*/
#line 923 "./mixal.yw"


void
resolve_forward(Symbol*f)
{
ref*p;

for(p= f->reflist;p;p= p->next){
memory[p->address]&= (B3-1);
memory[p->address]|= f->value<<(BYTESIZE*3);
}
}/*:53*/
